// include file for building tftpserver with "testharness" on a
// normally hosted linux system.

#include <unistd.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <string.h>

#define CONFIG_CMD_NET
typedef uint16_t ushort;
typedef uint8_t  uchar;

#define CFG_HZ 100

typedef void   rxhand_f(uchar *, unsigned, unsigned, unsigned);
typedef void   thand_f(void);
typedef ulong          IPaddr_t;

typedef enum { BOOTP, RARP, ARP, TFTP, DHCP, PING, DNS, NFS, CDP, NETCONS, SNTP, TFTPSRV } proto_t;

// Internet Protocol (IP) header.

typedef struct {
	uchar		ip_hl_v;	/* header length and version	*/
	uchar		ip_tos;		/* type of service		*/
	ushort		ip_len;		/* total length			*/
	ushort		ip_id;		/* identification		*/
	ushort		ip_off;		/* fragment offset field	*/
	uchar		ip_ttl;		/* time to live			*/
	uchar		ip_p;		/* protocol			*/
	ushort		ip_sum;		/* checksum			*/
	IPaddr_t	ip_src;		/* Source IP address		*/
	IPaddr_t	ip_dst;		/* Destination IP address	*/
	ushort		udp_src;	/* UDP source port		*/
	ushort		udp_dst;	/* UDP destination port		*/
	ushort		udp_len;	/* Length of UDP packet		*/
	ushort		udp_xsum;	/* Checksum			*/
} IP_t;

#define IP_HDR_SIZE_NO_UDP	(sizeof (IP_t) - 8)
#define IP_HDR_SIZE		(sizeof (IP_t))
#define NetEthHdrSize()         16

extern uchar *NetTxPacket;
extern void NetSetHandler(rxhand_f * f);
extern void NetSetTimeout(ulong iv, thand_f * f);
extern void NetSendUDPPacket(uchar *ether, IPaddr_t dest, int dport, int sport, int len);
extern void NetStartAgain(void);
extern int NetLoop(proto_t proto);
extern int  NetState;
#define NETLOOP_CONTINUE        1
#define NETLOOP_RESTART         2
#define NETLOOP_SUCCESS         3
#define NETLOOP_FAIL            4

extern void hexDump(void *p, unsigned len);

// the following doesn't really accomplish anything other than prevent
// warnings about unused static fuction

#define U_BOOT_CMD(name,maxargs,rep,cmd,usage,help) \
  void* dontUseThisVariable_itsOnlyInTheTestHarness_ ##name = (void*)cmd;

typedef unsigned cmd_tbl_t;

#define simple_strtoul(s,p,b) strtoul(s,p,b)

#define do_reset()  exit(1)

#define Trace() printf("%s:%d\n",__FILE__,__LINE__)

void  run_command(char *cmd, int unused);
